SystemOrganization addCategory: #SWA014!

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed speedSaver id direction world currentStep maxAllowedSize minAllowedSize minAllowedSpeed maxAllowedSpeed realCenter upgradeList game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Blob
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Blob commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Blob methodsFor: 'body transformation' stamp: 'MV 1/27/2017 13:03'!
checkForEvolution
	self bodysize > 100 ifTrue: [self evolve].! !

!SWA014Blob methodsFor: 'body transformation' stamp: 'TZ 1/27/2017 18:27'!
evolve
	self flag: 'Anpassen für Score. Ein Counter muss hochgezählt werden'.
	self game showEvolveOptions.
	self bodysize: 50.
	self level: self level + 1.
	! !

!SWA014Blob methodsFor: 'initialization' stamp: 'MV 1/27/2017 13:01'!
initialize
	super initialize.
	self speed: 3.0.
	self level: 0.! !

!SWA014Blob methodsFor: 'constants' stamp: 'Tc 1/13/2017 14:24'!
isBlob
 	^true.! !

!SWA014Blob methodsFor: 'accessing' stamp: 'MV 1/27/2017 12:11'!
level
	^ level.! !

!SWA014Blob methodsFor: 'accessing' stamp: 'MV 1/27/2017 12:12'!
level: aNumber
	level := aNumber.! !

!SWA014Blob methodsFor: 'movement' stamp: 'MV 1/3/2017 00:34'!
moveAutomatically
	self swaworld realCenter: self swaworld realCenter - (self speed * self direction).
	self swaworld refreshCenter.
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014Blob methodsFor: 'movement' stamp: 'L.K. 1/13/2017 14:51'!
movementConstant
	^3.! !

!SWA014Blob methodsFor: 'upgrade management' stamp: 'TZ 1/27/2017 18:21'!
receiveUpgrade: anUpgrade

	self game upgradeBar add: anUpgrade.! !

!SWA014Blob methodsFor: 'override' stamp: 'MV 1/21/2017 15:30'!
step
	super step.
	
	self 
		direction: (self calculateDirection: (self calculateRealCenterFor: World activeHand center));
		moveAutomatically;
		yourself.! !

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'movement' stamp: 'MV 1/21/2017 15:30'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."
calculateDirection: target
	|direction|
	direction := super calculateDirection: target realCenter.
	^self < target
		ifTrue: [direction negated]
		ifFalse: [direction].
	! !

!SWA014Enemy methodsFor: 'override' stamp: 'MV 1/27/2017 12:30'!
step
	self 
		direction: (self calculateDirection: self nearestEnemy);
		moveAutomatically;
		yourself. 
	
	self upgradeList do: [:aUpgrade|
		aUpgrade activateIfNotCooling].
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:37'!
< aLivingThing
	^self bodysize < aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:39'!
> aLivingThing
	^self bodysize > aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 21:39'!
addMassOf: aLivingThing
	self bodysize: 2 * ((self squaredRadius + aLivingThing squaredRadius) sqrt).! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:39'!
bigNumber
	^SmallInteger maxVal.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 12/16/2016 12:09'!
bodysize: x
	x < (self maxAllowedSize)
		ifTrue: [
			x > (self minAllowedSize) 
				ifTrue: [	bodysize := x]
				ifFalse: [bodysize := self minAllowedSize]]
		ifFalse: [bodysize := self maxAllowedSize].
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/27/2017 12:49'!
calculateDirection: target
	^ self vectorToPoint: target.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/13/2017 01:04'!
calculateRealCenterFor: aPosition
	self flag: 'TODISCUSS: In welche Klasse gehört diese Methode?'.
	^aPosition - self swaworld realCenter + self swaworld radius asPoint.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/13/2017 15:55'!
checkForCollisions
	self 
		checkForCollisionsWithLivingThings;
		checkForCollisionsWithFood;
		"checkForCollisionsWithFood;" "Zur Zeit ist food nicht aktiv, deswegen ist es nicht nötig auf Kollisionen zu prüfen"
		yourself.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/13/2017 00:17'!
checkForCollisionsWithFood
	self swaworld listOfFood do: [:eatable|
		(self distanceTo: (self calculateRealCenterFor: eatable center)) < self squaredRadius ifTrue: [
			self eat: eatable]].! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/12/2017 22:40'!
checkForCollisionsWithLivingThings
	self swaworld listOfLivingThings do: [:enemy|
		(self checkForOverlapWith: enemy) ifTrue: [
			enemy < self 
				ifTrue: [	enemy goBehind.
						(self distanceTo: enemy realCenter) < self squaredRadius ifTrue: [
							self eat: enemy]] 
				ifFalse: [enemy comeToFront].
			self swaworld image goBehind]] without: self.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/10/2016 14:04'!
checkForOverlapWith: enemy
	^(self bottom > enemy top and: 
	    self top < enemy bottom and:
	    self left < enemy right and:
	    self right > enemy left).
! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 1/12/2017 22:31'!
distanceTo: enemy
	^((enemy x - self realCenter x) squared) +
	 ((enemy y - self realCenter y) squared). "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 1/27/2017 18:29'!
eat: prey
	self addMassOf: prey.

	self swaworld listOfEnemies remove: prey ifAbsent: [].
	self swaworld listOfFood remove: prey ifAbsent: [].
	
	prey isBlob not
 		ifTrue: [	prey delete.
				self game spawnEnemy.]
		ifFalse: [self game gameOver].
		
	self isBlob ifTrue: [self checkForEvolution.].! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 1/27/2017 18:22'!
game
	
	^ game.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 1/27/2017 18:22'!
game: aGame

	game := aGame.! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'MV 1/27/2017 12:10'!
initialize
	super initialize.
	
	self 
		maxAllowedSize: 800;
		maxAllowedSpeed: 1000;
		minAllowedSize: 10;
		minAllowedSpeed: 0;
		currentStep: 0;
		speed: 2.0;
		speedSaver: 2.0;
		direction: 0.0 asPoint;
		borderWidth: 2; "these initial values don't change at runtime"
		upgradeList: Dictionary new;
		yourself.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 1/12/2017 19:45'!
isBlob
	^false.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSize
	^maxAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:32'!
maxAllowedSize: aNumber
	maxAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSpeed
	^maxAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:12'!
maxAllowedSpeed: aNumber
	maxAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
minAllowedSize
	^minAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:33'!
minAllowedSize: aNumber
	minAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:36'!
minAllowedSpeed
	^minAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:13'!
minAllowedSpeed: aNumber
	minAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/3/2017 00:33'!
moveAutomatically
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 1/7/2017 15:15'!
nearestEnemy
	|smallestDistance nearestEnemyobject currentDistance|
	
	smallestDistance := self bigNumber.
	nearestEnemyobject := self.
		
	self swaworld listOfLivingThings do: [:enemy| 
		currentDistance := self distanceTo: (enemy realCenter).
		currentDistance  < smallestDistance ifTrue: [
			smallestDistance := currentDistance.
			nearestEnemyobject := enemy]]
	without: self.

	^nearestEnemyobject.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 21:29'!
radius
	^self bodysize/2.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:29'!
realCenter
	^realCenter.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:30'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014LivingThing methodsFor: 'upgrade management' stamp: 'TZ 1/27/2017 19:23'!
receiveUpgrade: anUpgrade

	self addMorph: anUpgrade.
	anUpgrade hide.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/20/2016 16:15'!
refreshCenter
	self center: self swaworld realCenter - ((self swaworld width / 2)@(self swaworld height / 2)) + self realCenter.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:17'!
refreshSize
	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/20/2017 12:13'!
saveSpeed
	self speedSaver: self speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/16/2016 15:48'!
speed: x
	x < self maxAllowedSpeed 
		ifTrue: [
			x> (self minAllowedSpeed) 
			ifTrue: [speed := x]
			ifFalse: [speed := self minAllowedSpeed]]
		ifFalse: [speed := self maxAllowedSpeed].
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/20/2017 12:08'!
speedSaver
	^ speedSaver.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/20/2017 12:08'!
speedSaver: aSpeed
	speedSaver := aSpeed.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:31'!
squaredRadius
	"Der Radius wird Quadriert, damit wir, wenn wir mit ihm vergleichen, keine Wurzel ziehen müssen (Phytagoras)"
	^self radius squared. ! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 1/7/2017 14:27'!
step
	self checkForCollisions.
	
	self	refreshSize;
		"refreshCenter;"
		yourself.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'Tc 12/31/2016 15:34'!
stepNumber
	"This is used to keep the stepTime up to date"
	self flag: 'Zur Zeit nicht verwendeet und auch verhaltenstechnisch als (leicht) fehlerhaft anzusehen'.
	
	^self speed ~= 0
	   	ifTrue: [	10 * self bodysize / self speed]
		ifFalse: [SmallInteger maxVal. "Stepping very slow"].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/21/2016 19:03'!
stepTime
	^1.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:55'!
swaworld: aWorld
	world := aWorld.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:38'!
upgradeList
	^upgradeList.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:37'!
upgradeList: aList
	upgradeList := aList.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 1/27/2017 12:48'!
vectorToPoint: aPoint
	|vector|
	vector := aPoint - self realCenter.
	^ vector normalized.! !

CircleMorph subclass: #SWA014Trap
	instanceVariableNames: 'swaworld scalingFactor preySpeed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Trap methodsFor: 'collision handling' stamp: 'Tc 2/2/2017 20:08'!
checkForCollisionsWithLivingThings

	self swaworld listOfLivingThings do: [:aLivingThing|
		(aLivingThing distanceTo: (aLivingThing calculateRealCenterFor: self center)) < aLivingThing squaredRadius ifTrue: [
			self collideWith: aLivingThing]].! !

!SWA014Trap methodsFor: 'collision handling' stamp: 'Tc 2/2/2017 20:14'!
collideWith: aLivingThing

	self inflictAilmentTo: aLivingThing.
	self futureDo: #removeAilmentOf: at: (self timeUntilTrapEffectIsBackedUp) args: (Array with: aLivingThing).
	self delete.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'Tc 2/2/2017 20:12'!
inflictAilmentTo: aLivingThing

	aLivingThing bodysize: aLivingThing bodysize / self scalingFactor.
	self preySpeed: aLivingThing speed.
	aLivingThing speed: (self stopping).! !

!SWA014Trap methodsFor: 'initialization' stamp: 'Tc 2/2/2017 20:15'!
initialize

	super initialize.
	self 
		color: Color blue;
		extent: 15 asPoint;
		scalingFactor: 1.5;
		yourself.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:13'!
preySpeed

	^ preySpeed.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:13'!
preySpeed: aSpeed

	preySpeed := aSpeed.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'Tc 2/2/2017 20:12'!
removeAilmentOf: aLivingThing

	aLivingThing speed: self preySpeed.
	aLivingThing bodysize: aLivingThing bodysize * self scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:13'!
scalingFactor

	^ scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:13'!
scalingFactor: aFactor

	scalingFactor := aFactor.! !

!SWA014Trap methodsFor: 'override' stamp: 'Tc 2/2/2017 20:15'!
step

	self checkForCollisionsWithLivingThings.! !

!SWA014Trap methodsFor: 'override' stamp: 'Tc 2/2/2017 20:15'!
stepTime

	^100.! !

!SWA014Trap methodsFor: 'constants' stamp: 'Tc 2/2/2017 20:11'!
stopping

	^0.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:13'!
swaworld

	^ swaworld.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:13'!
swaworld: aWorld

	swaworld := aWorld.! !

!SWA014Trap methodsFor: 'constants' stamp: 'Tc 2/2/2017 20:13'!
timeUntilTrapEffectIsBackedUp

	^5000.! !

Morph subclass: #SWA014EvolveMenu
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'TZ 1/27/2017 18:38'!
game
	
	^ game.! !

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'TZ 1/27/2017 18:38'!
game: aGame

	game := aGame.! !

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'TZ 1/27/2017 17:10'!
initialize

	super initialize.
	
	self color: Color transparent.! !

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'TZ 1/27/2017 19:04'!
showOptions: anOptionList
	|evolveOption|
	
	1 to: (anOptionList size - 3) do: [:aNumber| anOptionList remove: anOptionList atRandom].
	
	anOptionList do: [:anOption|
		evolveOption := SWA014EvolveOption newWithUpgrade: anOption.
		evolveOption game: self game.
		evolveOption center: ((anOptionList indexOf: anOption) / (anOptionList size  + 1) * self width)@(self center y).
		self addMorph: evolveOption].
	anOptionList isEmpty ifFalse: [self game pause].! !

Morph subclass: #SWA014EvolveOption
	instanceVariableNames: 'upgrade game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EvolveOption class methodsFor: 'initialization' stamp: 'MV 1/20/2017 14:47'!
newWithUpgrade: anUpgrade
	^ self new
		initializeWith: anUpgrade;
		yourself.! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:24'!
createChooseButton
	| chooseButton |
	
	chooseButton := SWA014ChooseButton new.
	chooseButton center: (self center x)@(self height * 3 / 4).
	self addMorph: chooseButton.! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:25'!
createStringMorphForOption
	| stringMorph |

	stringMorph := StringMorph new.
	stringMorph acceptValue: self upgrade.	
	stringMorph center: (self center x)@(self height * 1 / 4).
	self addMorph: stringMorph.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:30'!
game

	^ game.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:30'!
game: aGame

	game := aGame.! !

!SWA014EvolveOption methodsFor: 'upgrade managment' stamp: 'TZ 1/27/2017 18:35'!
getChosen

	self game enable: self upgrade for: self game swaworld blob.
	self owner delete.
	self game continue.
	self game upgradesUnavailableToPlayerBlob remove: self upgrade ifAbsent: [].! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:29'!
initializeWith: anUpgrade
	
	self 
		extent: 150@250;
		color: Color white;
		upgrade: anUpgrade;
		createChooseButton;
		createStringMorphForOption;
		yourself.
! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:32'!
upgrade

	^ upgrade.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:32'!
upgrade: anUpgrade

	upgrade := anUpgrade.! !

Morph subclass: #SWA014Game
	instanceVariableNames: 'upgradeDictionary upgradesUnavailableToPlayerBlob isPaused world maxLivingThingSize numberOfEnemies upgradeBar aPosition'
	classVariableNames: 'Highscore'
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 1/20/2017 15:20'!
highscore
	^ Highscore! !

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 1/20/2017 15:20'!
highscore: aHighscore
	Highscore := aHighscore! !

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'Tc 1/27/2017 10:16'!
open
	self flag: 'TODO: Here is some code commented out: Decide what to do with it later'.
	^self new spawnPlayerBlob; openHighscoreWindow; "spawnEnemy;" "spawnFood;" openInWorld; spawnUpgradeBar; yourself.! !

!SWA014Game methodsFor: 'game events' stamp: 'TZ 1/27/2017 16:59'!
continue

	self swaworld listOfLivingThings do: [:aLivingThing| aLivingThing speed: aLivingThing speedSaver].
	self isPaused: false.! !

!SWA014Game methodsFor: 'upgrade managment' stamp: 'TZ 1/27/2017 18:36'!
enable: upgrade for: aLivingThing
	|anUpgrade anAssociation|
	anUpgrade := (self upgradeDictionary at: upgrade ifAbsent: [SWA014NullUpgrade]) new.
	anUpgrade upgradeOwner: aLivingThing.
	aLivingThing receiveUpgrade: anUpgrade.
		
	anAssociation := Association new key: upgrade value: anUpgrade.
	aLivingThing upgradeList add: anAssociation.
! !

!SWA014Game methodsFor: 'game events' stamp: 'TZ 1/27/2017 16:59'!
gameOver

	self delete.! !

!SWA014Game methodsFor: 'input events' stamp: 'MV 1/21/2017 15:59'!
handleKeystroke: anEvent
	|keyValue|
	keyValue := anEvent keyValue.
	
	keyValue = 49 ifTrue: [ "Taste: 1"
		(self swaworld blob upgradeList at: #Trap ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 50 ifTrue: [ "Taste: 2"
		(self swaworld blob upgradeList at: #Speedboost ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 51 ifTrue: [ "Taste: 3"
		(self swaworld blob upgradeList at: #Shockwave ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 52 ifTrue: [ "Taste: 4"
		(self swaworld blob upgradeList at: #Drain ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 120 ifTrue: [ "Taste: x"
		self delete].	
	keyValue = 112 ifTrue: [ "Taste: p"
		self isPaused 
			ifTrue: [self continue]
			ifFalse: [self pause]].	
	
	Transcript show: keyValue.! !

!SWA014Game methodsFor: 'input events' stamp: 'MV 1/3/2017 01:49'!
handlesMouseOver: anEvent
	^true.! !

!SWA014Game methodsFor: 'initialization' stamp: 'TZ 1/27/2017 19:14'!
initialize
	super initialize.

	self 
		extent: ActiveWorld extent;
		clipSubmorphs: true;
		
		initializeWorld;
		
		"initial values"
		maxLivingThingSize: 75;
		numberOfEnemies:50;
		isPaused: false;
	
		initializeDictionary;
		initializeUpgradesUnavailableToPlayerBlob;
		
		spawnPlayerBlob;
		openHighscoreWindow;
		spawnUpgradeBar;
		openInWorld;
		
		yourself.
		
	1 to: self numberOfEnemies do:[:x| self spawnEnemy ]. 
		
! !

!SWA014Game methodsFor: 'initialization' stamp: 'TZ 1/27/2017 19:30'!
initializeDictionary
	
	self upgradeDictionary: (Dictionary newFrom: {
		#Trap->SWA014TrapUpgrade.
		#Speedboost->SWA014SpeedboostUpgrade.
		#Drain->SWA014DrainUpgrade.
		#Shockwave->SWA014ShockwaveUpgrade}).! !

!SWA014Game methodsFor: 'initialization' stamp: 'TZ 1/27/2017 19:32'!
initializeUpgradesUnavailableToPlayerBlob

	self upgradesUnavailableToPlayerBlob: self upgradeDictionary keys asOrderedCollection.! !

!SWA014Game methodsFor: 'initialization' stamp: 'TZ 1/27/2017 19:20'!
initializeWorld
	
	self swaworld: SWA014World new.
	self addMorph: self swaworld.
	self swaworld
		game: self;
		center: self center;
		realCenter: self center.
	self swaworld image center: self center.
	
	
! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
isPaused

	^ isPaused.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
isPaused: aBoolean

	isPaused := aBoolean.! !

!SWA014Game methodsFor: 'constants' stamp: 'TZ 1/27/2017 16:54'!
maxLivingThingSize

	^ maxLivingThingSize.
	! !

!SWA014Game methodsFor: 'constants' stamp: 'TZ 1/27/2017 16:53'!
maxLivingThingSize: aSize

	maxLivingThingSize := aSize.! !

!SWA014Game methodsFor: 'input events' stamp: 'MV 1/3/2017 01:50'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self.! !

!SWA014Game methodsFor: 'input events' stamp: 'MV 1/3/2017 01:51'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil.! !

!SWA014Game methodsFor: 'world manipulation' stamp: 'TZ 1/27/2017 16:41'!
movePlayerBlobToCenter
	self swaworld realCenter: self swaworld realCenter + ((self swaworld blob calculateRealCenterFor: self center) - self swaworld blob realCenter).
	self swaworld refreshCenter.! !

!SWA014Game methodsFor: 'constants' stamp: 'TZ 1/27/2017 16:54'!
numberOfEnemies

	^ numberOfEnemies.! !

!SWA014Game methodsFor: 'constants' stamp: 'TZ 1/27/2017 16:54'!
numberOfEnemies: aNumber

	numberOfEnemies := aNumber.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 1/13/2017 15:12'!
openHighscoreWindow
	|newHighscoreWindow|
	
	newHighscoreWindow := SWA014Highscore new. 
	newHighscoreWindow swaworld: self swaworld.
	newHighscoreWindow openInWorld.
	self addMorph: newHighscoreWindow.! !

!SWA014Game methodsFor: 'game events' stamp: 'TZ 1/27/2017 17:00'!
pause

	self swaworld listOfLivingThings do: [:aLivingThing|
		aLivingThing
			saveSpeed;
			speed: 0].
	self isPaused: true.! !

!SWA014Game methodsFor: 'game events' stamp: 'TZ 1/27/2017 19:04'!
showEvolveOptions
	|evolveMenu|
	
	evolveMenu := SWA014EvolveMenu new.
	evolveMenu
		game: self;
		extent: self extent;
		center: self center;
		showOptions: self upgradesUnavailableToPlayerBlob copy;
		yourself.
	self addMorph: evolveMenu.! !

!SWA014Game methodsFor: 'spawning' stamp: 'TZ 1/27/2017 18:25'!
spawnEnemy
	|enemy random  randomNumber0 randomNumber1 randomNumber2 randomNumber3 randomNumber4 listOfKeys upgradeNumberToEnable|
	
	enemy := SWA014Enemy new.
	self maxLivingThingSize: (self swaworld blob bodysize * 1.1) asInteger.
	listOfKeys := self upgradeDictionary keys asOrderedCollection.
	random := Random new.
	randomNumber0 := random nextInt: 4.
	randomNumber0 > 1 ifTrue: [self maxLivingThingSize: 100].
	randomNumber1 := random nextInt: self swaworld width.
	randomNumber2 := random nextInt: self swaworld height.
	randomNumber3 := random nextInt: self maxLivingThingSize.
	
	upgradeNumberToEnable := self swaworld blob level.
	listOfKeys size < upgradeNumberToEnable ifTrue: [upgradeNumberToEnable := listOfKeys size].
	1 to: upgradeNumberToEnable do: [:aNumber|
		| randomValue |
		randomNumber4 :=  random nextInt: listOfKeys size.
		randomValue := listOfKeys atRandom.
		self enable: randomValue for: enemy.
		listOfKeys remove: randomValue].
	
	enemy realCenter: randomNumber1@randomNumber2.
	enemy bodysize: randomNumber3.	
	enemy swaworld: self swaworld.
	enemy game: self.
	enemy refreshCenter.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.! !

!SWA014Game methodsFor: 'spawning' stamp: 'TZ 1/27/2017 18:25'!
spawnPlayerBlob
	|newPlayerBlob|
	newPlayerBlob := SWA014Blob new.
	newPlayerBlob color: Color red.
	newPlayerBlob bodysize: 60.
	newPlayerBlob realCenter: (self swaworld width / 2)@(self swaworld height / 2).
	newPlayerBlob center: self center.
	newPlayerBlob swaworld: self swaworld.
	newPlayerBlob game: self.
	self swaworld blob: newPlayerBlob.
	self swaworld addMorph: newPlayerBlob.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 1/20/2017 18:59'!
spawnUpgradeBar
	|aBar|
	aBar := SWA014UpgradeBar new position: (self bounds right - 125)@(self bounds top + 50).
	self addMorph: aBar.
	self upgradeBar: aBar.
	! !

!SWA014Game methodsFor: 'override' stamp: 'TZ 1/27/2017 16:41'!
step

	"Make sure the PlayerBlob is in the center"
	self movePlayerBlobToCenter.
! !

!SWA014Game methodsFor: 'override' stamp: 'MV 1/13/2017 02:07'!
stepTime
	^5000.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
swaworld

	^ world.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
swaworld: aWorld

	world := aWorld.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeBar

	^ upgradeBar.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeBar: aBar

	upgradeBar := aBar.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeDictionary

	^ upgradeDictionary.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeDictionary: aDictionary

	upgradeDictionary := aDictionary.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:50'!
upgradesUnavailableToPlayerBlob

	^ upgradesUnavailableToPlayerBlob.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:49'!
upgradesUnavailableToPlayerBlob: aList

	upgradesUnavailableToPlayerBlob := aList.! !

Morph subclass: #SWA014Menu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Menu class methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:32'!
open
	^SWA014Menu new openInWorld.! !

!SWA014Menu methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:16'!
initialize 
	super initialize.
	
	self
		extent: World extent;
		addMorph: (ImageMorph new image: (Form fromFileNamed: 'Background.jpg'));
		addMorph: (SWA014StartButton new center: (self width /2)@((12/25) * self height));
		addMorph: (SWA014EndButton new center: (self width /2)@((13/25) * self height));
		clipSubmorphs: true;
		yourself.! !

Morph subclass: #SWA014UpgradeBar
	instanceVariableNames: 'upgradeCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:21'!
add: anUpgrade

	self addMorph: anUpgrade.
	anUpgrade center: (self center x)@(self position y + self constantDisplacementInYDirection + (self upgradeCount * self scalingFactor)).
	anUpgrade extent: 75@75. "TODO: Finde guten Konstantennamen"
	self upgradeCount: self upgradeCount + 1.! !

!SWA014UpgradeBar methodsFor: 'constants' stamp: 'Tc 2/2/2017 20:18'!
constantDisplacementInYDirection

	^50.! !

!SWA014UpgradeBar methodsFor: 'initialization' stamp: 'Tc 2/2/2017 20:04'!
initialize

	super initialize.
	self 
		extent: 50@500;
		color: Color transparent;
		upgradeCount: 0;
		yourself.! !

!SWA014UpgradeBar methodsFor: 'constants' stamp: 'Tc 2/2/2017 20:17'!
scalingFactor

	^100.! !

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:04'!
upgradeCount

	^ upgradeCount.! !

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'Tc 2/2/2017 20:04'!
upgradeCount: aNumber

	upgradeCount := aNumber.! !

Morph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies listOfFood blob game realCenter image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'world content' stamp: 'MV 1/13/2017 16:54'!
blob
	^blob.! !

!SWA014World methodsFor: 'world content' stamp: 'MV 1/13/2017 16:54'!
blob: aBlob
	blob := aBlob.! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:31'!
checkForBorderCollisions
	self listOfLivingThings do: [:enemy | 
		self checkOnRightSide: enemy.
		self checkOnLeftSide: enemy.
		self checkOnTopSide: enemy.
		self checkOnBottomSide: enemy].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:31'!
checkOnBottomSide: anEnemy
	anEnemy bounds bottom > self bounds bottom ifTrue: [
			anEnemy isBlob ifTrue: [
				self realCenter: (self realCenter x)@(anEnemy bounds bottom - self radius).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy realCenter x)@(self worldSize - anEnemy radius).
			anEnemy refreshCenter]! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:29'!
checkOnLeftSide: anEnemy
	anEnemy bounds left < self bounds left ifTrue: [
			anEnemy isBlob ifTrue: [
				self realCenter: (anEnemy bounds left + self radius)@(self realCenter y).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy radius)@(anEnemy realCenter y).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:27'!
checkOnRightSide: anEnemy
	anEnemy bounds right > self bounds right ifTrue:	[
			anEnemy isBlob ifTrue: [
				self realCenter: (anEnemy bounds right - self radius)@(self realCenter y).
				self refreshCenter]. 
			anEnemy realCenter: (self worldSize - anEnemy radius)@(anEnemy realCenter y).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:30'!
checkOnTopSide: anEnemy
	anEnemy bounds top < self bounds top ifTrue: [
			anEnemy isBlob ifTrue: [
				self realCenter: (self realCenter x)@(anEnemy bounds top + self radius).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy realCenter x)@(anEnemy radius).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image
	^ image.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image: anImage
	image := anImage.! !

!SWA014World methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:09'!
initialize
	super initialize.
		
	self 
		image: (ImageMorph new image: (Form fromFileNamed: 'Background.jpg'));"Be sure, that the picture is in the resource folder with that name"
		addMorph: self image;
		listOfEnemies: Set new;
		listOfFood: Set new;
		blob: nil;
		worldSize: 3000;
		extent: self worldSize asPoint;	
		center: 0 asPoint;
		realCenter: 0.0 asPoint;
		yourself.
		! !

!SWA014World methodsFor: 'world content' stamp: 'L.K. 1/13/2017 14:52'!
listOfEnemies
	^ listOfEnemies.! !

!SWA014World methodsFor: 'world content' stamp: 'L.K. 1/13/2017 14:53'!
listOfEnemies: aList
	listOfEnemies := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:39'!
listOfFood
	^ listOfFood.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/2/2017 22:57'!
listOfFood: aList
	listOfFood := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 21:15'!
listOfLivingThings
	|listOfLivingThings|
	listOfLivingThings := self listOfEnemies copy.
	listOfLivingThings add: self blob.
	^listOfLivingThings.! !

!SWA014World methodsFor: 'body transformation' stamp: 'Tc 1/13/2017 14:34'!
radius
	^worldSize / 2.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter
	^realCenter.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014World methodsFor: 'movement' stamp: 'MV 1/7/2017 15:57'!
refreshCenter
	self center: self realCenter.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'MV 12/22/2016 11:00'!
step
	self 
		checkForBorderCollisions;
		"refreshCenter;"
		yourself.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'L.K. 1/13/2017 14:52'!
stepTime
	^100.! !

!SWA014World methodsFor: 'body transformation' stamp: 'L.K. 1/13/2017 14:53'!
worldSize
	^worldSize.! !

!SWA014World methodsFor: 'body transformation' stamp: 'L.K. 1/13/2017 14:53'!
worldSize: anObject
	worldSize := anObject.! !

ImageMorph subclass: #SWA014Upgrade
	instanceVariableNames: 'upgradeOwner coolDownMorph cooling cooldown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Upgrade commentStamp: 'MV 1/21/2017 14:48' prior: 0!
To add a new Upgrade change: Game->initializeDictionary, Game->handleKeystroke, and right now Game->showEvolveOptions. !

SWA014Upgrade subclass: #SWA014DrainUpgrade
	instanceVariableNames: 'drainTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014DrainUpgrade methodsFor: 'starting up' stamp: 'Tc 2/2/2017 19:40'!
activateUpgrade

	self drainTarget: self upgradeOwner nearestEnemy.
	self drainTarget borderColor: Color lavender.
	self startStepping.
	self futureDo: #stopStepping at: (self timeUntilStopStepping) args: #().
	self drainTarget futureDo: #borderColor: at: (self timeUntilBorderColourChanging) args: (Array with: Color black).! !

!SWA014DrainUpgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:42'!
drainTarget

	^ drainTarget! !

!SWA014DrainUpgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:42'!
drainTarget: anEnemy

	drainTarget := anEnemy! !

!SWA014DrainUpgrade methodsFor: 'initialization' stamp: 'Tc 2/2/2017 19:42'!
initialize

	super initialize.
	self 
		image: (Form fromFileNamed: 'DrainUpgrade.png');
		stopStepping;
		yourself.! !

!SWA014DrainUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 19:45'!
sizeGainedPerHalfSecond
	
	^3.! !

!SWA014DrainUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 19:46'!
sizeLostPerHalfSecond

	^3.! !

!SWA014DrainUpgrade methodsFor: 'override' stamp: 'Tc 2/2/2017 19:47'!
step

	self drainTarget = nil ifFalse: [
		self drainTarget bodysize: (self drainTarget bodysize - self sizeLostPerHalfSecond).
		self upgradeOwner bodysize: (self upgradeOwner bodysize + self sizeGainedPerHalfSecond)].! !

!SWA014DrainUpgrade methodsFor: 'override' stamp: 'Tc 2/2/2017 19:44'!
stepTime

	^ 500.
	! !

!SWA014DrainUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 19:32'!
timeUntilBorderColourChanging

	^4000.! !

!SWA014DrainUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 19:34'!
timeUntilStopStepping

	^4000.! !

SWA014Upgrade subclass: #SWA014NullUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014NullUpgrade methodsFor: 'starting up' stamp: 'Tc 2/2/2017 19:37'!
activateUpgrade
 "This class should do nothing. It solves the problem, what should happen, if the player tries to use an upgrade, which he hasn't unlocked yet. In this case, the player uses this NullUpgrade, which does nothing."! !

SWA014Upgrade subclass: #SWA014ShockwaveUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014ShockwaveUpgrade methodsFor: 'starting up' stamp: 'Tc 2/2/2017 19:56'!
activateUpgrade
	"This upgrade pushes your opponents back."

	self upgradeOwner swaworld listOfLivingThings do: [:enemy|
		((self upgradeOwner distanceTo: enemy realCenter) < (self upgradeOwner radius + self toleratedDistanceConstant) squared) ifTrue: [
			enemy realCenter: enemy realCenter + (self pushingFactor * (self upgradeOwner vectorToPoint: enemy realCenter)).
			enemy refreshCenter]] without: self upgradeOwner.! !

!SWA014ShockwaveUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 19:52'!
pushingFactor
	
	^200.! !

!SWA014ShockwaveUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 19:56'!
toleratedDistanceConstant
	
	^200.! !

SWA014Upgrade subclass: #SWA014SpeedboostUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014SpeedboostUpgrade methodsFor: 'starting up' stamp: 'Tc 2/2/2017 20:02'!
activateUpgrade

	self upgradeOwner 
		speed: self upgradeOwner speed + self speedBoostConstant ;
		futureDo: #speed: at: (self timeUntilSpeedboostIsBackedUp) args: (Array with: (self upgradeOwner speed - self speedBoostConstant));
		yourself.! !

!SWA014SpeedboostUpgrade methodsFor: 'initialization' stamp: 'Tc 2/2/2017 20:03'!
initialize

	super initialize.
	self image: (Form fromFileNamed: 'SpeedBoostUpgrade.png').! !

!SWA014SpeedboostUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 19:56'!
speedBoostConstant

	^11.! !

!SWA014SpeedboostUpgrade methodsFor: 'constants' stamp: 'Tc 2/2/2017 20:02'!
timeUntilSpeedboostIsBackedUp

	^1000.! !

SWA014Upgrade subclass: #SWA014TrapUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014TrapUpgrade methodsFor: 'starting up' stamp: 'Tc 2/2/2017 20:03'!
activateUpgrade

 	self spawnTrap.
			! !

!SWA014TrapUpgrade methodsFor: 'initialization' stamp: 'Tc 2/2/2017 20:03'!
initialize

	super initialize.
	self image: (Form fromFileNamed: 'TrapUpgrade.png').! !

!SWA014TrapUpgrade methodsFor: 'world manipulation' stamp: 'Tc 2/2/2017 20:04'!
spawnTrap
	|aTrap|
	
	aTrap := SWA014Trap new.
	aTrap swaworld: self upgradeOwner swaworld.
	aTrap center: self upgradeOwner center - (self upgradeOwner direction * self upgradeOwner bodysize).
	self upgradeOwner swaworld addMorph: aTrap.
! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'Tc 2/2/2017 19:40'!
activateIfNotCooling

	self cooling ifFalse: [
		self
			activateUpgrade;
			cooling: true;
			futureDo: #cooling: at: (self cooldownTime) args: (Array with: false); "After the cooledownTime is over, the cooling status is automatically back off to false"
			yourself].
		self cooldownMorph show.
		self cooldownMorph futureDo: #hide at: (self cooldownTime) args: #(). "Switching back to non-cooledown picture after cooledownTime is over"! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'Tc 2/2/2017 19:41'!
activateUpgrade
	"The different Upgrades should overwrite this. This method gets called, when the player wants to use an Upgrade."
	"To add a new Upgrade change: Game->initializeDictionary, Game->handleKeystroke, and right now Game->showEvolveOptions."
	
	self SubclassResponsibility.
	! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
cooldownMorph

	^ coolDownMorph.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
cooldownMorph: aMorph

	coolDownMorph := aMorph.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
cooldownTime

	^ cooldown.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
cooldownTime: aTime

	cooldown := aTime.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
cooling

	^ cooling.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
cooling: aBoolean

	cooling := aBoolean.! !

!SWA014Upgrade methodsFor: 'initialization' stamp: 'Tc 2/2/2017 19:41'!
initialize

	super initialize.
	self cooldownMorph: ImageMorph new.
		
	self 
		cooling: false;
		cooldownTime: 10000;
		addMorph:self cooldownMorph;
		yourself.
		
	self cooldownMorph image: (Form fromFileNamed: 'Cooldown.png').
	self cooldownMorph hide.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
upgradeOwner

	^upgradeOwner.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'Tc 2/2/2017 19:41'!
upgradeOwner: aLivingThing

	upgradeOwner := aLivingThing.! !

SimpleButtonMorph subclass: #SWA014ChooseButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014ChooseButton methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:31'!
initialize 

	super initialize.

	self 
		label: 'Choose!!';
		color: Color red;
		yourself.! !

!SWA014ChooseButton methodsFor: 'event handling' stamp: 'TZ 1/27/2017 16:31'!
mouseDown: anEvent

	"The owner is always an EvolveOption"
	self owner getChosen.! !

SimpleButtonMorph subclass: #SWA014EndButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EndButton methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:31'!
initialize 

	super initialize.

	self 
		label: 'End Game';
		color: Color red;
		yourself.! !

!SWA014EndButton methodsFor: 'event handling' stamp: 'TZ 1/27/2017 16:31'!
mouseDown: anEvent

	"The owner is the menu, this button closes it"
	self owner delete.! !

SimpleButtonMorph subclass: #SWA014StartButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014StartButton methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:19'!
initialize 
	super initialize.

	self 
		label: 'Start Game';
		color: Color green;
		yourself.! !

!SWA014StartButton methodsFor: 'event handling' stamp: 'TZ 1/27/2017 16:12'!
mouseDown: evt
	SWA014Game new.! !

StringMorph subclass: #SWA014Highscore
	instanceVariableNames: 'value world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 12:03'!
highscoreValue
	^value.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 12:03'!
highscoreValue: aValue
	value := aValue.! !

!SWA014Highscore methodsFor: 'initialization' stamp: 'Tc 1/13/2017 15:33'!
initialize 
	super initialize.
	
	self
		highscoreValue: 0;
		acceptValue: 0;
		color: Color red;
		width: 500;
		height: 500;
		yourself.! !

!SWA014Highscore methodsFor: 'updating' stamp: 'Tc 1/13/2017 15:42'!
setNewHighscore
	|highscoreValueAsString|
	
	((self highscoreValue + 60) < self swaworld blob bodysize ) ifTrue: [self highscoreValue:  (self swaworld blob bodysize - 60) asInteger].
	highscoreValueAsString := self highscoreValue asString.
	self fontName: 'BitstreamVeraSans' size: 60.
	! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 15:42'!
step
	self setNewHighscore.
	self acceptValue: value.! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 11:58'!
stepTime
	^1.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:54'!
swaworld
	^world
! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:55'!
swaworld: aWorld
	world := aWorld! !
